/* UNH CS 758 assignment 7

   symbol table: maintains a two-way mapping between symbol names
   (strings) and symbol ids (unique integers)
*/


#include <stdio.h> /* FILE */


typedef struct {
  char *key;
  int  value;
} st_entry;


typedef struct {
  int size; /* of both entries and keys */
  st_entry *entries; /* hash table: char* -> int */
  int count; /* will be the next new id */
  char **keys;  /* array: int -> char* */
} symbol_table;


symbol_table *make_symtab(void);
void free_symtab(symbol_table *st);

void fprint_symtab(FILE *outfile, symbol_table *st);

int symtab_count(symbol_table *st);
int symtab_id_for_name(symbol_table *st, char *name);
char *symtab_name_for_id(symbol_table *st, int symbol_id);


/* EOF */
